from eth_keys import datatypes
from typing import Any

class BaseECCBackend:
    PublicKey: Any = ...
    PrivateKey: Any = ...
    Signature: Any = ...
    def __init__(self) -> None: ...
    def ecdsa_sign(self, msg_hash: bytes, private_key: PrivateKey) -> datatypes.Signature: ...
    def ecdsa_verify(self, msg_hash: bytes, signature: datatypes.Signature, public_key: datatypes.PublicKey) -> bool: ...
    def ecdsa_recover(self, msg_hash: bytes, signature: datatypes.Signature) -> datatypes.PublicKey: ...
    def private_key_to_public_key(self, private_key: datatypes.PrivateKey) -> datatypes.PublicKey: ...
